/*  -*- Mode: C -*- 
 * This file is part of xui
 * 
 * x11jpstr.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Thu Jan 25 22:55:47 1996
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Wed Jan 31 23:27:09 1996
 * 
 * Copyright (C) 1995,1996 Todo Software All rights reserved.
 */

#include <stdio.h>
#include "byteord.h"
#include "gt/dev/x11gdev.h"

#if 1
#undef mbtowc
#define USE_XMBTOWC
#define USE_XWCHAR_STRING
#ifndef mbtowc
#ifdef USE_XWCHAR_STRING
#define wcslen(c) _Xwcslen(c)
#define wcscpy(d,s) _Xwcscpy(d,s)
#define wcsncpy(d,s,l) _Xwcsncpy(d,s,l)
#ifdef USE_XMBTOWC
#define mbtowc(wc,s,l) _Xmbtowc(wc,s,l)
#define mbstowcs(wc,s,l) _Xmbstowcs(wc,s,l)
#endif
#endif
#endif

#else


static 
mymbstowcs (wctext, text, len)
     wchar_t *wctext;
     char *text;
{
  wchar_t *base = wctext;
#if ENDIAN == 4321
  while (*text)
    {
      if (*text & 0x80)
	{
	  *(((char *) wctext) + 0) = 0;
	  *(((char *) wctext) + 1) = 0;
	  *(((char *) wctext) + 2) = *text;
	  *(((char *) wctext) + 3) = *(text + 1);
	  text += 2;
	}
      else
	{
	  *(((char *) wctext) + 0) = 0;
	  *(((char *) wctext) + 1) = 0;
	  *(((char *) wctext) + 2) = 0;
	  *(((char *) wctext) + 3) = *(text);
	  text++;
	}
      wctext++;
      if (wctext - base >= len)
	break;
    }
#else
  while (*text)
    {
      if (*text & 0x80)
	{
	  *(((char *) wctext) + 0) = *(text + 1);
	  *(((char *) wctext) + 1) = *text;
	  *(((char *) wctext) + 2) = 0;
	  *(((char *) wctext) + 3) = 0;
	  text += 2;
	}
      else
	{
	  *(((char *) wctext) + 0) = *(text);
	  *(((char *) wctext) + 1) = 0;
	  *(((char *) wctext) + 2) = 0;
	  *(((char *) wctext) + 3) = 0;
	  text++;
	}
      wctext++;
      if (wctext - base >= len)
	break;
    }
#endif
  *wctext = 0;
}
#define mbstowcs mymbstowcs
#endif

void 
DrawString16 (display, window, xfs, gc, x, y, text, len)
     Display *display;
     Window window;
     XFontSet xfs;
     GC gc;
     integer_t x, y;
     char *text;
     integer_t len;
{
  wchar_t wctext[256];
  memset (wctext, 0, sizeof (wctext));
  mbstowcs (wctext, text, len);
  XwcDrawString (display, window, xfs, gc, x, y, wctext, len);
}
