/*  -*- Mode: C -*- 
 * This file is part of xnetmaj
 * 
 * convini.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Thu Jan 25 23:01:38 1996
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Thu Jan 25 23:01:39 1996
 * 
 * Copyright (C) 1995,1996 Todo Software All rights reserved.
 */

#include "gt/widget/widget.h"

widget_t
button_create (parent, w, h, text, color, font, callback, arg)
     widget_t parent;
     char *text;
     integer_t w, h, color, font;
     void (*callback) ();
     void *arg;
{
  widget_t button;
  button = widget_create ("button", parent);
  widget_set_geometry (button, w, h);
  widget_configure (button, resource_text, text);
  widget_configure (button, resource_textcolor, color);
  widget_configure (button, resource_textfont, font);
  widget_add_callback (button,
		       resource_buttonpress_callback,
		       (void *) callback, arg);
  return button;
}

widget_t
text_create (parent, w, h, text, color, font, shadow)
     widget_t parent;
     char *text;
     integer_t w, h, color;
     integer_t font;
     integer_t shadow;
{
  widget_t header = widget_create ("text", parent);
  widget_set_geometry (header, w, h);
  widget_configure (header, resource_text, text);
  widget_configure (header, resource_textfont, font);
  widget_configure (header, resource_textcolor, color);
  widget_configure (header, resource_textshadow, shadow);
  return header;
}
