/*  -*- Mode: C -*- 
 * This file is part of j2c
 * 
 * vararg.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Thu Jan 25 22:59:45 1996
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Thu Jan 25 23:00:22 1996
 * 
 * Copyright (C) 1995,1996 Todo Software All rights reserved.
 */


#include <varargs.h>

call_varargs (va_alist)
     va_dcl
{
  va_list p;
  void *s;
  int (*fp) ();
  char *arg[20];
  int i = 0;
  va_start (p);

  fp = va_arg (p, void *);
  s = va_arg (p, void *);
  for (;; i++)
    {
      arg[i] = va_arg (p, char *);
      if (arg[i] == 0)
	{
	  break;
	}
    }
  (*fp) (s, i, &arg);
}

call_varargs2 (va_alist)
     va_dcl
{
  va_list p;
  void *s, *s2;
  int (*fp) ();
  char *arg[20];
  int i = 0;
  va_start (p);

  fp = va_arg (p, void *);
  s = va_arg (p, void *);
  s2 = va_arg (p, void *);

  for (;; i++)
    {
      arg[i] = va_arg (p, char *);
      if (arg[i] == 0)
	{
	  break;
	}
    }
  (*fp) (s, s2, i, &arg);
}
