/*  -*- Mode: C -*- 
 * This file is part of xnetmaj
 * 
 * intint.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Fri Apr 28 16:52:31 1995
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Tue Sep 26 21:16:18 1995
 * 
 *  Copyright (C) 1995,1996 Todo Software All rights reserved
 */

#include "xnet.h"
#include "xnetmaj.h"

#include "rc.c"

void
save_xrcfile ()
{
  FILE *fp;
  char *p;
  char buf[512];

  p = getenv ("HOME");
  if (p)
    {
      sprintf (buf, "%s/.xnetmaj", p);
      fp = fopen (buf, "w");
      if (fp)
	{
	  save_rcfile (fp);
	}
      fclose (fp);
    }
}

void
load_xrcfile ()
{
  char *p;
  char buf[512];

  p = getenv ("NETMAJ_LIB");
  if (p)
    {
      sprintf (buf, "%s/.xnetmaj", p);
      load_rcfile (buf);
    }
  p = getenv ("HOME");
  if (p)
    {
      sprintf (buf, "%s/.xnetmaj", p);
      load_rcfile (buf);
    }
}
/* end of file */
